whiteboard.h File Reference

The PurpleWhiteboard core object. More...

`#include "account.h"`

Go to the source code of this file.

## Data Structures

struct | _PurpleWhiteboard
| A PurpleWhiteboard. More...
struct | _PurpleWhiteboardUiOps
| The PurpleWhiteboard UI Operations. More...
struct | _PurpleWhiteboardPrplOps
| PurpleWhiteboard PRPL Operations. More...

## Typedefs

typedef struct _PurpleWhiteboardPrplOps | PurpleWhiteboardPrplOps
| Whiteboard PRPL Operations.
typedef struct _PurpleWhiteboard | PurpleWhiteboard
| A PurpleWhiteboard.
typedef struct _PurpleWhiteboardUiOps | PurpleWhiteboardUiOps
| The PurpleWhiteboard UI Operations.

## Functions

PurpleWhiteboard API
void | purple_whiteboard_set_ui_ops (PurpleWhiteboardUiOps *ops)
| Sets the UI operations. More...
void | purple_whiteboard_set_prpl_ops (PurpleWhiteboard *wb, PurpleWhiteboardPrplOps *ops)
| Sets the prpl operations for a whiteboard. More...
PurpleWhiteboard * | purple_whiteboard_create (PurpleAccount *account, const char *who, int state)
| Creates a whiteboard. More...
void | purple_whiteboard_destroy (PurpleWhiteboard *wb)
| Destroys a whiteboard. More...
void | purple_whiteboard_start (PurpleWhiteboard *wb)
| Starts a whiteboard. More...
PurpleWhiteboard * | purple_whiteboard_get_session (const PurpleAccount *account, const char *who)
| Finds a whiteboard from an account and user. More...
void | purple_whiteboard_draw_list_destroy (GList *draw_list)
| Destorys a drawing list for a whiteboard. More...
gboolean | purple_whiteboard_get_dimensions (const PurpleWhiteboard *wb, int *width, int *height)
| Gets the dimension of a whiteboard. More...
void | purple_whiteboard_set_dimensions (PurpleWhiteboard *wb, int width, int height)
| Sets the dimensions for a whiteboard. More...
void | purple_whiteboard_draw_point (PurpleWhiteboard *wb, int x, int y, int color, int size)
| Draws a point on a whiteboard. More...
void | purple_whiteboard_send_draw_list (PurpleWhiteboard *wb, GList *list)
| Send a list of points to draw to the buddy. More...
void | purple_whiteboard_draw_line (PurpleWhiteboard *wb, int x1, int y1, int x2, int y2, int color, int size)
| Draws a line on a whiteboard. More...
void | purple_whiteboard_clear (PurpleWhiteboard *wb)
| Clears a whiteboard. More...
void | purple_whiteboard_send_clear (PurpleWhiteboard *wb)
| Sends a request to the buddy to clear the whiteboard. More...
void | purple_whiteboard_send_brush (PurpleWhiteboard *wb, int size, int color)
| Sends a request to change the size and color of the brush. More...
gboolean | purple_whiteboard_get_brush (const PurpleWhiteboard *wb, int *size, int *color)
| Gets the size and color of the brush. More...
void | purple_whiteboard_set_brush (PurpleWhiteboard *wb, int size, int color)
| Sets the size and color of the brush. More...

## Detailed Description

The PurpleWhiteboard core object.

Definition in file whiteboard.h.

## Function Documentation

void purple_whiteboard_clear | ( | PurpleWhiteboard * | wb | ) |

Clears a whiteboard.

Parameters

  wb | The whiteboard.

PurpleWhiteboard* purple_whiteboard_create | ( | PurpleAccount * | account,
|  | const char * | who,
|  | int | state
| ) |  |

Creates a whiteboard.

Parameters

  account | The account.
  who | Who you're drawing with.
  state | The state.

Returns
  The new whiteboard

void purple_whiteboard_destroy | ( | PurpleWhiteboard * | wb | ) |

Destroys a whiteboard.

Parameters

  wb | The whiteboard.

void purple_whiteboard_draw_line | ( | PurpleWhiteboard * | wb,
|  | int | x1,
|  | int | y1,
|  | int | x2,
|  | int | y2,
|  | int | color,
|  | int | size
| ) |  |

Draws a line on a whiteboard.

Parameters

  wb | The whiteboard.
  x1 | The top-left x coordinate.
  y1 | The top-left y coordinate.
  x2 | The bottom-right x coordinate.
  y2 | The bottom-right y coordinate.
  color | The color to use.
  size | The brush size.

void purple_whiteboard_draw_list_destroy | ( | GList * | draw_list | ) |

Destorys a drawing list for a whiteboard.

Parameters

  draw_list | The drawing list.

void purple_whiteboard_draw_point | ( | PurpleWhiteboard * | wb,
|  | int | x,
|  | int | y,
|  | int | color,
|  | int | size
| ) |  |

Draws a point on a whiteboard.

Parameters

  wb | The whiteboard.
  x | The x coordinate.
  y | The y coordinate.
  color | The color to use.
  size | The brush size.

gboolean purple_whiteboard_get_brush | ( | const PurpleWhiteboard * | wb,
|  | int * | size,
|  | int * | color
| ) |  |

Gets the size and color of the brush.

Parameters

  wb | The whiteboard
  size | The size of the brush
  color | The color of the brush

Returns
  TRUE if the size and color were set.

gboolean purple_whiteboard_get_dimensions | ( | const PurpleWhiteboard * | wb,
|  | int * | width,
|  | int * | height
| ) |  |

Gets the dimension of a whiteboard.

Parameters

  wb | The whiteboard.
  width | The width to be set.
  height | The height to be set.

Returns
  TRUE if the values of width and height were set.

PurpleWhiteboard* purple_whiteboard_get_session | ( | const PurpleAccount * | account,
|  | const char * | who
| ) |  |

Finds a whiteboard from an account and user.

Parameters

  account | The account.
  who | The user.

Returns
  The whiteboard if found, otherwise `NULL`.

void purple_whiteboard_send_brush | ( | PurpleWhiteboard * | wb,
|  | int | size,
|  | int | color
| ) |  |

Sends a request to change the size and color of the brush.

Parameters

  wb | The whiteboard
  size | The size of the brush
  color | The color of the brush

void purple_whiteboard_send_clear | ( | PurpleWhiteboard * | wb | ) |

Sends a request to the buddy to clear the whiteboard.

Parameters

  wb | The whiteboard

void purple_whiteboard_send_draw_list | ( | PurpleWhiteboard * | wb,
|  | GList * | list
| ) |  |

Send a list of points to draw to the buddy.

Parameters

  wb | The whiteboard
  list | A GList of points

void purple_whiteboard_set_brush | ( | PurpleWhiteboard * | wb,
|  | int | size,
|  | int | color
| ) |  |

Sets the size and color of the brush.

Parameters

  wb | The whiteboard
  size | The size of the brush
  color | The color of the brush

void purple_whiteboard_set_dimensions | ( | PurpleWhiteboard * | wb,
|  | int | width,
|  | int | height
| ) |  |

Sets the dimensions for a whiteboard.

Parameters

  wb | The whiteboard.
  width | The width.
  height | The height.

void purple_whiteboard_set_prpl_ops | ( | PurpleWhiteboard * | wb,
|  | PurpleWhiteboardPrplOps * | ops
| ) |  |

Sets the prpl operations for a whiteboard.

Parameters

  wb | The whiteboard for which to set the prpl operations
  ops | The prpl operations to set

void purple_whiteboard_set_ui_ops | ( | PurpleWhiteboardUiOps * | ops | ) |

Sets the UI operations.

Parameters

  ops | The UI operations to set

void purple_whiteboard_start | ( | PurpleWhiteboard * | wb | ) |

Starts a whiteboard.

Parameters

  wb | The whiteboard.